/* dmesg.c -- Print out the contents of the kernel ring buffer
\input cnoweb 
\job{}
\* Created: Sat Oct  9 16:19:47 1993
\* Revised: Sat Oct  9 16:25:36 1993 by faith@cs.unc.edu
\* Copyright 1993 Theodore Ts'o (tytso@athena.mit.edu)
\* This program comes with ABSOLUTELY NO WARRANTY.
 */

#include <linux/unistd.h>
#include <stdio.h>

#define __NR_klog __NR_syslog

static inline _syscall3(int,klog,int,type,char *,b,int,len)

int main( int argc, char **argv )
{
   char buf[4096];
   int  i;
   int  cmd = 3;

   if (argc > 2) {
      fprintf( stderr, "Usage: %s [-c]\n", argv[0] );
      exit( 1 );
   }

   if (argc > 1 && !strcmp( argv[1], "-c" )) {
      cmd = 4;
   }

   i = klog( cmd, buf, sizeof( buf ) );
   if (i < 0) {
      perror( "klog" );
      exit( 1 );
   }

   write( 1, buf, i );
   return 0;
}
